package com.rjconsultores.ventaboletos.entidad;

import java.util.Date;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name = "INSCRICAO_ESTADUAL")
public class InscricaoEstadual {
	private Long inscricaoestadualId;

	private Empresa empresa;
	private Estado estado;
	private Boolean activo;
	private Date fecmodif;
	private Integer usuarioId;
	private String numInscricaoEstadual;
	private String logradouro;
	private String numero;
	private String complemento;
	private String cep;
	private String bairro;
	private Ciudad cidade;
	private String cnpj;
	private String equivalenciaAG;
	private Boolean isBPe;
	private Boolean indHabilitaIEDescentralizada;
	private Parada origemIEDescentralizada;
	private Boolean indFormaPagoOutrosSemCartao;
	private String numInscricaoMunicipal;
	

	public InscricaoEstadual() {
		super();
	}

	public InscricaoEstadual(String inscricaoEstadual, Empresa empresa, Estado estado, Integer usuarioId,
			String logradouro, String numero, String complemento, String cep, String bairro, Ciudad cidade, String cnpj,String numInscricaoMunicipal) {
		super();
		this.numInscricaoEstadual = inscricaoEstadual;
		this.empresa = empresa;
		this.estado = estado;
		this.fecmodif = new Date();
		this.activo = true;
		this.usuarioId = usuarioId;
		this.logradouro = logradouro;
		this.numero=numero;
		this.complemento=complemento;
		this.cep=cep;
		this.bairro=bairro;
		this.cidade=cidade;
		this.cnpj=cnpj;
		this.numInscricaoMunicipal =numInscricaoMunicipal;
	}

	@SequenceGenerator(name = "INSCRICAO_ESTADUAL_SEQ", sequenceName = "INSCRICAO_ESTADUAL_SEQ", allocationSize = 1)
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "INSCRICAO_ESTADUAL_SEQ")
	@Column(name = "INSCRICAOESTADUAL_ID", unique = true, nullable = false, precision = 15, scale = 0)
	public Long getInscricaoestadualId() {
		return inscricaoestadualId;
	}

	public void setInscricaoestadualId(Long inscricaoestadualId) {
		this.inscricaoestadualId = inscricaoestadualId;
	}

	@Column(name = "NUMINSCRICAOESTADUAL", length = 20)
	public String getNumInscricaoEstadual() {
		return numInscricaoEstadual;
	}

	public void setNumInscricaoEstadual(String inscricaoEstadual) {
		this.numInscricaoEstadual = inscricaoEstadual;
	}

	@JoinColumn(name = "EMPRESA_ID")
	@ManyToOne
	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}

	@JoinColumn(name = "ESTADO_ID")
	@ManyToOne
	public Estado getEstado() {
		return estado;
	}

	public void setEstado(Estado estado) {
		this.estado = estado;
	}

	@Column(name = "ACTIVO", precision = 1, scale = 0)
	public Boolean getActivo() {
		return activo;
	}

	public void setActivo(Boolean activo) {
		this.activo = activo;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "FECMODIF", length = 7)
	public Date getFecmodif() {
		return fecmodif;
	}

	public void setFecmodif(Date fecmodif) {
		this.fecmodif = fecmodif;
	}

	@Column(name = "USUARIO_ID", precision = 7, scale = 0)
	public Integer getUsuarioId() {
		return usuarioId;
	}

	public void setUsuarioId(Integer usuarioId) {
		this.usuarioId = usuarioId;
	}
	@Column(name = "LOGRADOURO")
	public String getLogradouro() {
		return logradouro;
	}

	public void setLogradouro(String logradouro) {
		this.logradouro = logradouro;
	}

	@Column(name = "NUMERO")
	public String getNumero() {
		return numero;
	}

	public void setNumero(String numero) {
		this.numero = numero;
	}

	@Column(name = "COMPLEMENTO")
	public String getComplemento() {
		return complemento;
	}

	public void setComplemento(String complemento) {
		this.complemento = complemento;
	}

	@Column(name = "CEP")
	public String getCep() {
		return cep;
	}

	public void setCep(String cep) {
		this.cep = cep;
	}

	@Column(name = "BAIRRO")
	public String getBairro() {
		return bairro;
	}

	public void setBairro(String bairro) {
		this.bairro = bairro;
	}

	@OneToOne(cascade = CascadeType.MERGE)
	@JoinColumn(name = "CIUDAD_ID")
	public Ciudad getCidade() {
		return cidade;
	}

	public void setCidade(Ciudad cidade) {
		this.cidade = cidade;
	}

	@Column(name = "CNPJ")
	public String getCnpj() {
		return cnpj;
	}

	public void setCnpj(String cnpj) {
		this.cnpj = cnpj;
	}

	@Column(name = "EQUIVALENCIAAG")
	public String getEquivalenciaAG() {
		return equivalenciaAG;
	}

	public void setEquivalenciaAG(String equivalenciaAG) {
		this.equivalenciaAG = equivalenciaAG;
	}
	
	@Column(name = "INDBPE")
	public Boolean getIsBPe() {
		return isBPe;
	}

	public void setIsBPe(Boolean isBPe) {
		this.isBPe = isBPe;
	}
	
	@Column(name="NUMINSCRICAOMUNICIPAL")
	public String getNumInscricaoMunicipal() {
		return numInscricaoMunicipal;
	}

	public void setNumInscricaoMunicipal(String numInscricaoMunicipal) {
		this.numInscricaoMunicipal = numInscricaoMunicipal;
	}
	
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((getInscricaoestadualId() == null) ? 0 : getInscricaoestadualId().hashCode());
		return result;
	}

	@Override
	public boolean equals(Object object) {
		if (!(object instanceof InscricaoEstadual)) {
			return false;
		}
		InscricaoEstadual other = (InscricaoEstadual) object;
		if ((this.getInscricaoestadualId() == null && other.getInscricaoestadualId() != null) || (this.getInscricaoestadualId() != null && !this.getInscricaoestadualId().equals(other.getInscricaoestadualId()))) {
			return false;
		}
		return true;
	}

	@Override
	public String toString() {
		return String.format("%s-%s", estado.getCveestado(), numInscricaoEstadual);
	}
	
	@ManyToOne
	@JoinColumn(name = "ORIGEM_ID_IEDESCENTRALIZADA")
	public Parada getOrigemIEDescentralizada() {
		return origemIEDescentralizada;
	}

	public void setOrigemIEDescentralizada(Parada origemIEDescentralizada) {
		this.origemIEDescentralizada = origemIEDescentralizada;
	}

	@Column(name = "INDHABILITAIEDESCENTRALIZADA")
	public Boolean getIndHabilitaIEDescentralizada() {
		return indHabilitaIEDescentralizada != null ? indHabilitaIEDescentralizada : false;
	}

	public void setIndHabilitaIEDescentralizada(Boolean indHabilitaIEDescentralizada) {
		this.indHabilitaIEDescentralizada = indHabilitaIEDescentralizada;
	}

	public Boolean getIndFormaPagoOutrosSemCartao() {
		return indFormaPagoOutrosSemCartao;
	}

	public void setIndFormaPagoOutrosSemCartao(Boolean indFormaPagoOutrosSemCartao) {
		this.indFormaPagoOutrosSemCartao = indFormaPagoOutrosSemCartao;
	}
}
